// Generated by gir (https://github.com/gtk-rs/gir @ 9d38245d1165)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git @ 7ebd4478b4a5)
// DO NOT EDIT

#![allow(non_camel_case_types, non_upper_case_globals, non_snake_case)]
#![allow(
    clippy::approx_constant,
    clippy::type_complexity,
    clippy::unreadable_literal,
    clippy::upper_case_acronyms
)]
#![cfg_attr(feature = "dox", feature(doc_cfg))]

#[allow(unused_imports)]
use libc::{
    c_char, c_double, c_float, c_int, c_long, c_short, c_uchar, c_uint, c_ulong, c_ushort, c_void,
    intptr_t, size_t, ssize_t, uintptr_t, FILE,
};

#[allow(unused_imports)]
use glib::{gboolean, gconstpointer, gpointer, GType};

// Enums
pub type ManetteEventType = c_int;
pub const MANETTE_EVENT_NOTHING: ManetteEventType = -1;
pub const MANETTE_EVENT_BUTTON_PRESS: ManetteEventType = 0;
pub const MANETTE_EVENT_BUTTON_RELEASE: ManetteEventType = 1;
pub const MANETTE_EVENT_ABSOLUTE: ManetteEventType = 2;
pub const MANETTE_EVENT_HAT: ManetteEventType = 3;

// Unions
#[repr(C)]
pub struct ManetteEvent {
    _data: [u8; 0],
    _marker: core::marker::PhantomData<(*mut u8, core::marker::PhantomPinned)>,
}

impl ::std::fmt::Debug for ManetteEvent {
    fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {
        f.debug_struct(&format!("ManetteEvent @ {:p}", self))
            .finish()
    }
}

// Records
#[derive(Copy, Clone)]
#[repr(C)]
pub struct ManetteDeviceClass {
    pub parent_class: gobject::GObjectClass,
}

impl ::std::fmt::Debug for ManetteDeviceClass {
    fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {
        f.debug_struct(&format!("ManetteDeviceClass @ {:p}", self))
            .field("parent_class", &self.parent_class)
            .finish()
    }
}

#[derive(Copy, Clone)]
#[repr(C)]
pub struct ManetteMonitorClass {
    pub parent_class: gobject::GObjectClass,
}

impl ::std::fmt::Debug for ManetteMonitorClass {
    fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {
        f.debug_struct(&format!("ManetteMonitorClass @ {:p}", self))
            .field("parent_class", &self.parent_class)
            .finish()
    }
}

#[repr(C)]
pub struct ManetteMonitorIter {
    _data: [u8; 0],
    _marker: core::marker::PhantomData<(*mut u8, core::marker::PhantomPinned)>,
}

impl ::std::fmt::Debug for ManetteMonitorIter {
    fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {
        f.debug_struct(&format!("ManetteMonitorIter @ {:p}", self))
            .finish()
    }
}

// Classes
#[repr(C)]
pub struct ManetteDevice {
    _data: [u8; 0],
    _marker: core::marker::PhantomData<(*mut u8, core::marker::PhantomPinned)>,
}

impl ::std::fmt::Debug for ManetteDevice {
    fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {
        f.debug_struct(&format!("ManetteDevice @ {:p}", self))
            .finish()
    }
}

#[repr(C)]
pub struct ManetteMonitor {
    _data: [u8; 0],
    _marker: core::marker::PhantomData<(*mut u8, core::marker::PhantomPinned)>,
}

impl ::std::fmt::Debug for ManetteMonitor {
    fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {
        f.debug_struct(&format!("ManetteMonitor @ {:p}", self))
            .finish()
    }
}

#[link(name = "manette-0.2")]
extern "C" {

    //=========================================================================
    // ManetteEventType
    //=========================================================================
    pub fn manette_event_type_get_type() -> GType;

    //=========================================================================
    // ManetteEvent
    //=========================================================================
    pub fn manette_event_get_type() -> GType;
    pub fn manette_event_copy(self_: *const ManetteEvent) -> *mut ManetteEvent;
    pub fn manette_event_free(self_: *mut ManetteEvent);
    pub fn manette_event_get_absolute(
        self_: *const ManetteEvent,
        axis: *mut u16,
        value: *mut c_double,
    ) -> gboolean;
    pub fn manette_event_get_button(self_: *const ManetteEvent, button: *mut u16) -> gboolean;
    pub fn manette_event_get_device(self_: *const ManetteEvent) -> *mut ManetteDevice;
    pub fn manette_event_get_event_type(self_: *const ManetteEvent) -> ManetteEventType;
    pub fn manette_event_get_hardware_code(self_: *const ManetteEvent) -> u16;
    pub fn manette_event_get_hardware_index(self_: *const ManetteEvent) -> u16;
    pub fn manette_event_get_hardware_type(self_: *const ManetteEvent) -> u16;
    pub fn manette_event_get_hardware_value(self_: *const ManetteEvent) -> u16;
    pub fn manette_event_get_hat(
        self_: *const ManetteEvent,
        axis: *mut u16,
        value: *mut i8,
    ) -> gboolean;
    pub fn manette_event_get_time(self_: *const ManetteEvent) -> u32;

    //=========================================================================
    // ManetteMonitorIter
    //=========================================================================
    pub fn manette_monitor_iter_get_type() -> GType;
    pub fn manette_monitor_iter_free(self_: *mut ManetteMonitorIter);
    pub fn manette_monitor_iter_next(
        self_: *mut ManetteMonitorIter,
        device: *mut *mut ManetteDevice,
    ) -> gboolean;

    //=========================================================================
    // ManetteDevice
    //=========================================================================
    pub fn manette_device_get_type() -> GType;
    pub fn manette_device_get_name(self_: *mut ManetteDevice) -> *const c_char;
    pub fn manette_device_has_input(
        self_: *mut ManetteDevice,
        type_: c_uint,
        code: c_uint,
    ) -> gboolean;
    pub fn manette_device_has_rumble(self_: *mut ManetteDevice) -> gboolean;
    pub fn manette_device_has_user_mapping(self_: *mut ManetteDevice) -> gboolean;
    pub fn manette_device_remove_user_mapping(self_: *mut ManetteDevice);
    pub fn manette_device_rumble(
        self_: *mut ManetteDevice,
        strong_magnitude: u16,
        weak_magnitude: u16,
        milliseconds: u16,
    ) -> gboolean;
    pub fn manette_device_save_user_mapping(
        self_: *mut ManetteDevice,
        mapping_string: *const c_char,
    );

    //=========================================================================
    // ManetteMonitor
    //=========================================================================
    pub fn manette_monitor_get_type() -> GType;
    pub fn manette_monitor_new() -> *mut ManetteMonitor;
    pub fn manette_monitor_iterate(self_: *mut ManetteMonitor) -> *mut ManetteMonitorIter;

    //=========================================================================
    // Other functions
    //=========================================================================
    pub fn manette_get_resource() -> *mut gio::GResource;

}
